<form class="slack-form" name="slackForm">
    <div class="slack-form__header">
        <div class="slack-form__header-content">
            <div class="slack-form__integration-actions">
                <md-button name="enableIntegration"
                    title="{{ $ctrl.slackIntegration.enabled ? 'Disable' : 'Enable' }} integration"
                    aria-label="Enable/disable integration"
                    class="md-icon-button zf-icon-button"
                    ng-class="{ _enabled: $ctrl.slackIntegration.enabled }"
                    ng-disabled="!$ctrl.slackIntegrationSource || $ctrl.isSaving"
                    ng-click="$ctrl.onUpdateIntegration(slackForm)">
                    <md-icon>power_settings_new</md-icon>
                </md-button>
            </div>
        </div>
    </div>
    <div class="slack-form__body">
        <md-input-container>
            <label class="slack-form__label"
                name="slackIntegrationTokenLabel"
                for="slackIntegrationToken">
                Token
            </label>
            <input id="slackIntegrationToken"
                name="slackIntegrationToken"
                type="password"
                placeholder="Token"
                autocomplete="current-password"
                ng-minlength="::$ctrl.getValidationValue('token', 'minlength')"
                ng-maxlength="::$ctrl.getValidationValue('token', 'maxlength')"
                ng-pattern="::$ctrl.getValidationValue('token', 'pattern')"
                ng-disabled="$ctrl.isSaving"
                required
                ng-change="$ctrl.onTokenChange(slackForm.slackIntegrationToken)"
                ng-model-options="{ debounce: 500 }"
                ng-model="$ctrl.slackIntegration.token"/>
            <div ng-messages="slackForm.slackIntegrationToken.$error"
                ng-if="slackForm.slackIntegrationToken.$dirty || slackForm.slackIntegrationToken.$touched">
                <div ng-repeat="validation in $ctrl.validations.token"
                    ng-message-exp="validation.name">
                    <span>
                        <md-tooltip ng-if="!$ctrl.isTouchDevice && validation.additional"
                            md-autohide
                            md-delay="300"
                            md-direction="top">{{ validation.additional }}</md-tooltip>
                        {{ validation.message }}
                    </span>
                </div>
            </div>
        </md-input-container>
        <div class="slack-form__wrapper">
            <div class="slack-form__icon">
                <span class="slack-form__icon-label">Bot Icon</span>
                <div class="slack-form__icon-image">
                    <profile-photo ng-model="$ctrl.slackIntegration.botIconUrl"
                        size="40"
                        icon="crop_original">
                        <div class="slack-form__icon-image-container">
                            <i class="material-icons"
                                ng-click="$ctrl.showUploadImageDialog($event, slackForm)">add_a_photo</i>
                        </div>
                    </profile-photo>
                </div>
            </div>
            <md-input-container>
                <label class="slack-form__label"
                    name="slackIntegrationBotNameLabel"
                    for="slackIntegrationBotName">
                    Bot Name
                </label>
                <input id="slackIntegrationBotName"
                    name="slackIntegrationBotName"
                    type="text"
                    ng-minlength="::$ctrl.getValidationValue('botName', 'minlength')"
                    ng-maxlength="::$ctrl.getValidationValue('botName', 'maxlength')"
                    ng-disabled="$ctrl.isSaving"
                    required
                    placeholder="Bot Name"
                    ng-model-options="{ debounce: 500 }"
                    ng-model="$ctrl.slackIntegration.botName"/>
                <div ng-messages="slackForm.slackIntegrationBotName.$error"
                    ng-if="slackForm.slackIntegrationBotName.$dirty || slackForm.slackIntegrationBotName.$touched">
                    <div ng-repeat="validation in $ctrl.validations.botName"
                        ng-message-exp="validation.name">
                        <span>
                            <md-tooltip ng-if="!$ctrl.isTouchDevice && validation.additional"
                                md-autohide
                                md-delay="300"
                                md-direction="top">{{ validation.additional }}</md-tooltip>
                            {{ validation.message }}
                        </span>
                    </div>
                </div>
            </md-input-container>
        </div>
    </div>
    <div class="slack-form__footer">
        <div class="slack-form__footer-actions">
            <md-button class="md-raised btn-w-xs _left-icon _test-integration"
                ng-click="$ctrl.onTestIntegrationConnection(slackForm)"
                ng-disabled="slackForm.$invalid || $ctrl.isSaving">
                <md-icon class="material-icons">power_outline</md-icon>
                <span class="md-button__text">Test</span>
            </md-button>
            <md-button class="md-raised btn-w-xs"
                ng-click="$ctrl.onCancelFormChanges(slackForm)"
                ng-disabled="slackForm.$pristine || $ctrl.isSaving">Cancel</md-button>
            <md-button class="md-raised btn-w-xs md-primary"
                ng-click="$ctrl.onSaveIntegration(slackForm)"
                ng-disabled="slackForm.$pristine || slackForm.$invalid || $ctrl.isSaving">Save</md-button>
        </div>
        <div class="slack-form__footer-messages">
            <!--TODO: [-] refactor messages-->
            <div class="slack-form__footer-message _connecting no-animate"
                ng-if="$ctrl.testingStatus === 'loading'">
                <md-progress-circular class="slack-form__footer-message-icon"
                    md-mode="indeterminate"
                    md-diameter="16"></md-progress-circular>
                <div class="slack-form__footer-message-text">Connection</div>
            </div>
            <div class="slack-form__footer-message _connected no-animate"
                ng-if="$ctrl.testingStatus === 'success'">
                <md-icon class="slack-form__footer-message-icon material-icons">done</md-icon>
                <div class="slack-form__footer-message-text">Integration is connected.</div>
            </div>
            <div class="slack-form__footer-message _failed no-animate"
                ng-if="$ctrl.testingStatus === 'fail'">
                <md-icon class="slack-form__footer-message-icon material-icons">warning_amber</md-icon>
                <div class="slack-form__footer-message-text">
                    <div>Connection failed.</div>
                    <div ng-repeat="messageLine in $ctrl.testingStatusMessages">{{messageLine}}</div>
                </div>
            </div>
            <div class="slack-form__footer-message _failed no-animate"
                ng-if="$ctrl.testingStatus === 'error'">
                <md-icon class="slack-form__footer-message-icon material-icons">warning_amber</md-icon>
                <div class="slack-form__footer-message-text">
                    <div>Unable to check connection.</div>
                    <div ng-repeat="messageLine in $ctrl.testingStatusMessages">{{messageLine}}</div>
                </div>
            </div>
        </div>
    </div>
</form>
